<?php
/**
 * Constants.php
 *
 * This file is intended to group all constants to
 * make it easier for the site administrator to tweak
 * the login script.
 *
 * Written by: Jpmaster77 a.k.a. The Grandmaster of C++ (GMC)
 * Last Updated: August 19, 2004
 */
 
/**
 * Database Constants - these constants are required
 * in order for there to be a successful connection
 * to the MySQL database. Make sure the information is
 * correct.
 *
 * This is for the User database information. 
 */

if (!defined("DB_SERVER")) define("DB_SERVER", "127.0.0.1");
if (!defined("DB_USER")) define("DB_USER", "");
if (!defined("DB_PASS")) define("DB_PASS", "");
if (!defined("DB_NAME")) define("DB_NAME", "");


/**
 * This is the information for the football database. 
 * Presumably the username and password are the same for
 * both databases. Otherwise, you'll need to add those.
 */

if (!defined("NCAA_DB_SERVER")) define("NCAA_DB_SERVER", "");
if (!defined("NCAA_DB_NAME")) define("NCAA_DB_NAME", "");

/**
 * Database Table Constants - these constants
 * hold the names of all the database tables used
 * in the script.
 */
if (!defined("TBL_USERS")) define("TBL_USERS", "Users");
if (!defined("TBL_ACTIVE_USERS")) define("TBL_ACTIVE_USERS",  "active_users");
if (!defined("TBL_ACTIVE_GUESTS")) define("TBL_ACTIVE_GUESTS", "active_guests");
if (!defined("TBL_BANNED_USERS")) define("TBL_BANNED_USERS",  "banned_users");

/**
 * Special Names and Level Constants - the admin
 * page will only be accessible to the user with
 * the admin name and also to those users at the
 * admin user level. Feel free to change the names
 * and level constants as you see fit, you may
 * also add additional level specifications.
 * Levels must be digits between 0-9.
 */
if (!defined("ADMIN_NAME")) define("ADMIN_NAME", "admin");
if (!defined("GUEST_NAME")) define("GUEST_NAME", "Guest");
if (!defined("ADMIN_LEVEL")) define("ADMIN_LEVEL", 9);
if (!defined("USER_LEVEL")) define("USER_LEVEL",  1);
if (!defined("GUEST_LEVEL")) define("GUEST_LEVEL", 0);

/**
 * This boolean constant controls whether or
 * not the script keeps track of active users
 * and active guests who are visiting the site.
 */
if (!defined("TRACK_VISITORS")) define("TRACK_VISITORS", true);

/**
 * Timeout Constants - these constants refer to
 * the maximum amount of time (in minutes) after
 * their last page fresh that a user and guest
 * are still considered active visitors.
 */
if (!defined("USER_TIMEOUT")) define("USER_TIMEOUT", 10);
if (!defined("GUEST_TIMEOUT")) define("GUEST_TIMEOUT", 5);

/**
 * Cookie Constants - these are the parameters
 * to the setcookie function call, change them
 * if necessary to fit your website. If you need
 * help, visit www.php.net for more info.
 * <http://www.php.net/manual/en/function.setcookie.php>
 */
if (!defined("COOKIE_EXPIRE")) define("COOKIE_EXPIRE", 60*60*24*100);  //100 days by default
if (!defined("COOKIE_PATH")) define("COOKIE_PATH", "/");  //Avaible in whole domain

/**
 * Email Constants - these specify what goes in
 * the from field in the emails that the script
 * sends to users, and whether to send a
 * welcome email to newly registered users.
 */
if (!defined("EMAIL_FROM_NAME")) define("EMAIL_FROM_NAME", "Dave Areno");
if (!defined("EMAIL_FROM_ADDR")) define("EMAIL_FROM_ADDR", "areno5@embarqmail.com");
if (!defined("EMAIL_WELCOME")) define("EMAIL_WELCOME", false);

/**
 * This constant forces all users to have
 * lowercase usernames, capital letters are
 * converted automatically.
 */
if (!defined("ALL_LOWERCASE")) define("ALL_LOWERCASE", false);
?>
