<?php

//error_reporting(E_ALL);
//ini_set('display_errors', 'on');

require_once( "database_common.php" );

function get_all_games() 
{
	$sql = "SELECT * FROM Games";
	return do_football_query( $sql );
}

function get_all_games_by_week( $week, $season ) 
{
	if( $week < 0 or $week > 17 ) {
		die( "Invalid week provided: $week" );
	}
	$sql = "SELECT * FROM Games WHERE week=$week AND season_type='$season' ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_fbs_games_by_week( $week, $season ) 
{
	if( $week < 0 or $week > 17 ) {
		die( "Invalid week provided: $week" );
	}
	$sql = "SELECT * FROM Games WHERE week=$week AND season_type='$season' AND (home_division='fbs' OR away_division='fbs') ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_fbs_pick_games_by_week( $week, $season )
{
	$userSql = "SELECT GameID FROM Picks WHERE Week=$week";
	$result = do_user_query($userSql);
	$sql = "SELECT * FROM Games WHERE week=$week AND season_type='$season' AND (home_division='fbs' OR away_division='fbs') AND id IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['GameID'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_fbs_non_pick_games_by_week( $week, $season )
{
	$userSql = "SELECT GameID FROM Picks WHERE Week=$week";
	$result = do_user_query($userSql);
	$sql = "SELECT * FROM Games WHERE week=$week AND season_type='$season' AND (home_division='fbs' OR away_division='fbs') AND id NOT IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['GameID'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_fcs_pick_games_by_week( $week, $season )
{
	$userSql = "SELECT GameID FROM Picks WHERE Week=$week";
	$result = do_user_query($userSql);
	$sql = "SELECT * FROM Games WHERE week=$week AND season_type='$season' AND (home_division='fcs' OR away_division='fcs') AND id IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['GameID'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_fcs_non_pick_games_by_week( $week, $season )
{
	$userSql = "SELECT GameID FROM Picks WHERE Week=$week";
	$result = do_user_query($userSql);
	$sql = "SELECT * FROM Games WHERE week=$week AND season_type='$season' AND (home_division='fcs' OR away_division='fcs') AND id NOT IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['GameID'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_fcs_games_by_week( $week, $season )
{
	if( $week < 0 or $week > 17 ) {
		die( "Invalid week provided: $week" );
	}
	$sql = "SELECT * FROM Games WHERE week=$week AND season_type='$season' AND (home_division='fcs' OR away_division='fcs') ORDER BY start_date";
	return do_football_query( $sql );
}

function get_game_by_id( $id )
{
	$gameId = (int)$id;
	$sql = "SELECT * FROM Games WHERE id=$gameId";
	$result = do_football_query( $sql );
	if( count($result) == 0 )
		return null;
	return $result[0];
}

function get_game_away_team( $id ) 
{
	$sql = "SELECT away_id FROM Games WHERE id=$id";
	return do_football_query( $sql );
}

function get_game_home_team( $id ) 
{
	$sql = "SELECT home_id FROM Games WHERE id=$id";
	return do_football_query( $sql );
}

function get_game_date_time_by_id( $id )
{
	$sql = "SELECT completed FROM Games WHERE id=$id";
	$status = do_football_query( $sql )[0]["completed"];
	if($status) 
		return "Final";
	date_default_timezone_set('EST');
	$sql = "SELECT start_date FROM Games WHERE id=$id";
	$result = do_football_query( $sql );
	return date("D M j g:ia T", strtotime($result[0]["start_date"]));
}

function get_game_date_by_id( $id )
{
	date_default_timezone_set('EST');
	$sql = "SELECT start_date FROM Games WHERE id=$id";
	$result = do_football_query( $sql );
	$date = explode( "T", $result[0]["start_date"] );
	return $date[0];
}

function get_game_time_by_id( $id )
{
	date_default_timezone_set('EST');
	$sql = "SELECT start_date FROM Games WHERE id=$id";
	$result = do_football_query( $sql );
	$time = explode( "T", $result[0]["start_date"] );
	return $time[1];
}

function get_game_odds( $gameId )
{
	$sql = "SELECT spread,overUnder FROM Scoreboard WHERE id=$gameId";
	$results = do_football_query( $sql );
	if( count($results) == 0)
		$odds = ['spread' => '', 'overUnder' => ''];
	else
		$odds = $results[0];
	return $odds;
}

// Format for Picks Database:
// GameID INT PRIMARY KEY, Winner INT, week INT, type VARCHAR(255), points INT 

// Format for User Picks Database:
// GameID INT, userId INT, Winner INT, week INT 

function add_game_to_picks( $gameID, $gameType, $gamePoints, $gameWeek, $gameSeason, $gameFavorite )
{
	$sql = "INSERT INTO Picks (GameID, Winner, Week, Season, Type, Points, Underdog) VALUES ($gameID, 0, $gameWeek, '$gameSeason', '$gameType', $gamePoints, $gameFavorite)";
	return do_user_query( $sql );
}

function get_all_pick_games_by_week( $gameWeek, $gameSeason )
{
	$userSql = "SELECT GameID FROM Picks WHERE Week=$gameWeek";
	$result = do_user_query($userSql);
	$sql = "SELECT * FROM Games WHERE week=$gameWeek AND season_type='$gameSeason' AND GameID IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['GameID'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_non_pick_games_by_week( $gameWeek, $gameSeason )
{
	$userSql = "SELECT GameID FROM Picks WHERE Week=$gameWeek";
	$result = do_user_query($userSql);
	$sql = "SELECT * FROM Games WHERE week=$gameWeek AND season_type='$gameSeason' AND GameID NOT IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['GameID'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_pick_games_by_week_not_started( $gameWeek, $gameSeason )
{
	$userSql = "SELECT GameID FROM Picks WHERE Week=$gameWeek";
	$result = do_user_query($userSql);
	$sql = "SELECT * FROM Games WHERE week=$gameWeek AND season_type='$gameSeason' AND GameStatus=0 AND GameID IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['GameID'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ORDER BY start_date";
	return do_football_query( $sql );
}

function get_all_picks_by_week( $gameWeek, $gameSeason )
{
	$sql = "SELECT GameID FROM Picks WHERE Week=$gameWeek AND Season='$gameSeason'";
	return do_user_query( $sql );
}

function get_all_available_picks_by_week( $gameWeek, $gameSeason )
{
	$footballSql = "SELECT id FROM Games WHERE week=$gameWeek AND completed=FALSE";
	$result = do_football_query($footballSql);
	$sql = "SELECT GameID FROM Picks WHERE Week=$gameWeek AND Season='$gameSeason' AND GameID IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['id'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ";
	return do_user_query( $sql );
}

function get_all_picks_by_week_and_type( $gameWeek, $gameSeason, $gameType )
{
	$sql = "SELECT GameID FROM Picks WHERE Week=$gameWeek AND Season='$gameSeason' AND Type='$gameType' ";
	return do_user_query( $sql );
}

function get_all_available_picks_by_week_and_type( $gameWeek, $gameSeason, $gameType )
{
	$footballSql = "SELECT id FROM Games WHERE week=$gameWeek AND completed=FALSE";
	$result = do_football_query($footballSql);
	$sql = "SELECT GameID FROM Picks WHERE Week=$gameWeek AND Season='$gameSeason' AND Type='$gameType' AND GameID IN (";
	for($i = 0; $i < count($result); $i++) 
	{
		$sql .= $result[$i]['id'];
		if( $i+1 != count($result))
			$sql .= ',';
	}
	$sql .= ") ";
	return do_user_query( $sql );
}

function get_all_picks_by_week_not_finished( $gameWeek, $gameSeason )
{
	$sql = "SELECT GameID FROM Picks WHERE Week=$gameWeek AND Season='$gameSeason' AND Winner=0";
	return do_user_query( $sql );
}

function get_all_picks_by_week_and_type_not_finished( $gameWeek, $gameSeason, $gameType )
{
	$sql = "SELECT GameID FROM Picks WHERE Week=$gameWeek AND Season='$gameSeason' AND Winner=0 Type='$gameType'";
	return do_user_query( $sql );
}

function get_pick_by_game_id( $gameId )
{
	$sql = "SELECT * FROM Picks WHERE GameID=$gameId";
	return do_user_query( $sql );
}

function get_pick_Winner( $gameId )
{
	$sql = "SELECT Winner FROM Picks WHERE GameID=$gameId";
	return do_user_query( $sql );
}

function get_pick_underdog( $gameId )
{
	$sql = "SELECT Underdog FROM Picks WHERE GameID=$gameId";
	return do_user_query( $sql );
}

function get_pick_type_by_id( $id )
{
	$sql = "SELECT Type FROM Picks WHERE GameID=$id";
	return do_user_query( $sql );
}

function add_user_pick( $gameId, $userId, $Winner, $week, $season)
{
	$sql = "INSERT INTO UserPicks (GameID, UserID, Winner, Week, Season) VALUES ($gameId, $userId, $Winner, $week, '$season')";
	return do_user_query( $sql );
}

function delete_user_pick( $userId, $gameId )
{
	$sql = "DELETE FROM UserPicks WHERE UserID=$userId AND GameID=$gameId";
	return do_user_query( $sql );
}

function delete_users_picks_by_week( $userId, $week, $season )
{
	$sql = "DELETE FROM UserPicks WHERE UserID=$userId AND Week=$week AND Season='$season'";
	return do_user_query( $sql );
}

function update_user_pick( $gameId, $userId, $Winner, $week, $season )
{
	$sql = "UPDATE UserPicks SET Winner=$Winner WHERE GameID=$gameId AND UserID=$userId AND Week=$week AND Season='$season'";
	return do_user_query( $sql );
}

function get_user_picks_for_week( $userId, $gameWeek, $gameSeason )
{
	$sql = "SELECT GameID,Winner FROM UserPicks WHERE UserID=$userId AND Week=$gameWeek AND Season='$gameSeason'";
	return do_user_query( $sql );
}

function get_user_pick_by_game( $userId, $gameId )
{
	$sql = "SELECT Winner FROM UserPicks WHERE UserID=$userId AND GameID=$gameId";
	return do_user_query( $sql );
}

function get_user_upset_pick_by_week( $userId, $week, $season )
{
	$sql = "SELECT GameID FROM UserPicks WHERE UserID=$userId AND Week=$week AND Season='$season'";
	$userPicks = do_user_query( $sql );
	$sql = "SELECT GameID FROM Picks WHERE Week=$week AND Type='upset'";
	$upsetPicks = do_user_query( $sql );
	foreach( $userPicks as $userPick )
	{
		foreach( $upsetPicks as $upsetPick )
		{
			if( $upsetPick['GameID'] == $userPick['GameID'] )
				return $userPick['GameID'];
		}
	}
	return false;
}

function get_count_user_picks_by_type( $userId, $week, $season, $type )
{
	//$sql = "SELECT COUNT(PickID) FROM UserPicks WHERE UserID=$userId AND GameID IN (SELECT GameID from Picks WHERE Week=$week AND Season='$season' AND Type='$type')";
	$sql = "SELECT COUNT(PickID) FROM UserPicks WHERE UserID=$userId AND GameID IN (SELECT GameId FROM Picks WHERE week=$week AND Season='$season' AND Type='$type')";
	$result = do_user_query( $sql );
	if( count($result) == 0)
		return 0;
	return $result[0]['COUNT(PickID)'];
}

function get_underdog_by_game( $gameId )
{
	$sql = "SELECT Underdog FROM Picks WHERE GameID=$gameId";
	$result = do_user_query( $sql );
	if( count($result) == 0 )
		return 0;
	return $result[0]['Underdog'];
}

function delete_pick_by_id( $gameId )
{
	$sql = "DELETE FROM Picks WHERE GameID=$gameId";
	return do_user_query( $sql );
}

function get_number_of_pick_games_completed( $week, $season )
{
	$sql = "SELECT COUNT(*) FROM Picks WHERE Winner != 0 AND Week=$week AND Season='$season'";
	return do_user_query( $sql );
}

function get_user_picks_by_week_and_type( $userId, $week, $season, $type )
{
	$sql = "SELECT GameID,Winner FROM UserPicks WHERE UserID=$userId AND Week=$week AND Season='$season' ";
	$picks = do_user_query( $sql );
	$results = array();
	foreach( $picks as $pick )
	{
		$sql = "SELECT Type FROM Picks WHERE GameID=" . $pick['GameID'];
		$gameType = do_user_query( $sql )[0];
		if( $gameType['Type'] == $type )
			$results[] = $pick;
	}
	return $results;
}

function get_all_players_and_weekly_points( $gameWeek, $gameSeason )
{
	$sql = "SELECT UserID,Points FROM WeeklyResults WHERE Week=$gameWeek AND Season='$gameSeason' ORDER BY Points DESC";
	return do_user_query( $sql );
}

function get_user_points_by_week( $userId, $gameWeek, $gameSeason )
{
	$sql = "SELECT Points FROM WeeklyResults WHERE Week=$gameWeek AND Season='$gameSeason' and UserID=$userId";
	return do_user_query( $sql );
}
/*
function get_scoreboard_games()
{
	$sql = "SELECT * FROM Scoreboard";
	$results = do_football_query( $sql );
	if( count( $results ) == 0 )
		return [];
	return $results;
}

function get_pick_games_from_scoreboard()
{
	$sql = "SELECT * From Scoreboard WHERE id IN (SELECT GameID from Picks)";
	$results = do_football_query( $sql );
	if( count( $results ) == 0 )
		return [];
	return $results;
}
*/
function get_scoreboard_game_by_id( $gameId )
{
	$sql = "SELECT * From Scoreboard WHERE id=$gameId";
	$results = do_football_query( $sql );
	if( count( $results ) == 0 )
		return [];
	return $results[0];
}

?>
