class CFDB_Game():
	def __init__(self):
		self.id = 0
		self.season = 0
		self.week = 0
		self.season_type = ""
		self.start_date = ""
		self.start_time_tbd = False
		self.completed = False
		self.neutral_site = False
		self.conference_game = False
		self.attendance = 0
		self.venue_id = 0
		self.venue = ""
		self.home_id = 0
		self.home_team = ""
		self.home_conference = ""
		self.home_division = ""
		self.home_points = 0
		self.home_points_q1 = 0
		self.home_points_q2 = 0
		self.home_points_q3 = 0
		self.home_points_q4 = 0
		self.home_points_ot = 0 
		self.home_post_win_prob = 0.0
		self.home_pregame_elo = 0
		self.home_postgame_elo = 0
		self.away_id = 0
		self.away_team = ""
		self.away_conference = ""
		self.away_division = ""
		self.away_points = 0
		self.away_points_q1 = 0
		self.away_points_q2 = 0
		self.away_points_q3 = 0
		self.away_points_q4 = 0
		self.away_points_ot = 0
		self.away_post_win_prob = 0.0
		self.away_pregame_elo = 0
		self.away_postgame_elo = 0
		self.excitement_index = 0.0
		self.highlights = ""
		self.notes = ""

	def Print(self):
		print("Away Team: {0}\nHome Team: {1}\n".format(self.away_team, self.home_team))

	def Parse(self, gameData):
		self.id = gameData["id"]
		self.season = gameData["season"]
		self.week = gameData["week"]
		self.season_type = gameData["season_type"]
		self.start_date = gameData["start_date"]
		if gameData["start_time_tbd"] == True:
			self.start_time_tbd = True
		if gameData["completed"] == True:
			self.completed = True
		if gameData["neutral_site"] == True:
			self.neutral_site = True
		if gameData["conference_game"] == True:
			self.conference_game = True
		if gameData["attendance"] != None:
			self.attendance = gameData["attendance"]
		if gameData["venue_id"] != None:
			self.venue_id = gameData["venue_id"]
		else:
			self.venue_id = 0
		self.venue = gameData["venue"]
		self.home_id = gameData["home_id"]
		self.home_team = gameData["home_team"]
		if gameData["home_conference"] != None:
			self.home_conference = gameData["home_conference"]
		if gameData["home_division"] != None:
			self.home_division = gameData["home_division"]
		if gameData["home_points"] != None:
			self.home_points = gameData["home_points"]
		if gameData["home_line_scores"] != None and len(gameData["home_line_scores"]) != 0:
			if len(gameData["home_line_scores"]) > 4:
				self.home_points_ot = gameData["home_line_scores"][4]
			if len(gameData["home_line_scores"]) > 3:
				self.home_points_q4 = gameData["home_line_scores"][3]
			if len(gameData["home_line_scores"]) > 2:
				self.home_points_q3 = gameData["home_line_scores"][2]
			if len(gameData["home_line_scores"]) > 1:
				self.home_points_q2 = gameData["home_line_scores"][1]
			self.home_points_q1 = gameData["home_line_scores"][0]
		if gameData["home_post_win_prob"] != None:
			self.home_post_win_prob = round(float(gameData["home_post_win_prob"])*100, 2)
		if gameData["home_pregame_elo"] != None:
			self.home_pregame_elo = gameData["home_pregame_elo"]
		if gameData["home_postgame_elo"] != None:
			self.home_postgame_elo = gameData["home_postgame_elo"]
		self.away_id = gameData["away_id"]
		self.away_team = gameData["away_team"]
		if gameData["away_conference"] != None:
			self.away_conference = gameData["away_conference"]
		if gameData["away_division"] != None:
			self.away_division = gameData["away_division"]
		if gameData["away_points"] != None:
			self.away_points = gameData["away_points"]
		if gameData["away_line_scores"] != None and len(gameData["away_line_scores"]) != 0:
			if len(gameData["away_line_scores"]) > 4:
				self.away_points_ot = gameData["away_line_scores"][4]
			if len(gameData["away_line_scores"]) > 3:
				self.away_points_q4 = gameData["away_line_scores"][3]
			if len(gameData["away_line_scores"]) > 2:
				self.away_points_q3 = gameData["away_line_scores"][2]
			if len(gameData["away_line_scores"]) > 1:
				self.away_points_q2 = gameData["away_line_scores"][1]
			self.away_points_q1 = gameData["away_line_scores"][0]
		if gameData["away_post_win_prob"] != None:
			self.away_post_win_prob = round(float(gameData["away_post_win_prob"])*100, 2)
		if gameData["away_pregame_elo"] != None:
			self.away_pregame_elo = gameData["away_pregame_elo"]
		if gameData["away_postgame_elo"] != None:
			self.away_postgame_elo = gameData["away_postgame_elo"]
		if gameData["excitement_index"] != None:
			self.excitement_index = round(float(gameData["excitement_index"]), 2)
		if gameData["highlights"] != None:
			self.highlights = gameData["highlights"]
		if gameData["notes"] != None:
			self.notes = gameData["notes"]

class CFDB_Conference():
	def __init__(self):
		self.id = 0
		self.name = ""
		self.short_name = ""
		self.abbreviation = ""
		self.classification = ""
		
	def Parse(self, confData):
		if confData["id"] != None:
			self.id = confData["id"]
		else:
			self.id = 0
		# I have no idea why these are bassakwards, but whatever
		self.name = confData["short_name"]
		self.short_name = confData["name"]
		self.abbreviation = confData["abbreviation"]
		self.classification = confData["classification"]

class CFDB_Location():
	def __init__(self):
		self.id = 0
		self.name = ""
		self.capacity = 0
		self.grass = False
		self.city = ""
		self.state = ""
		self.zip = ""
		self.country_code = ""
		self.location = {"x" : 0.0, "y" : 0.0}
		self.elevation = 0
		self.year_constructed = 0
		self.dome = False
		self.timezone = ""

	def Parse(self, locationData):
		# ID marker may be "venue_id" or "id"
		if "venue_id" in locationData and locationData["venue_id"] != None:
			self.id = locationData["venue_id"]
		else:
			self.id = 0
		if "id" in locationData:
			self.id = locationData["id"]
		if locationData["name"] != None:
			self.name = locationData["name"]
		if locationData["capacity"] != None:
			self.capacity = locationData["capacity"]
		if locationData["grass"] == "true":
			self.grass = True
		if locationData["city"] != None:
			self.city = locationData["city"]
		if locationData["state"] != None:
			self.state = locationData["state"]
		if locationData["zip"] != None:
			self.zip = locationData["zip"]
		if locationData["country_code"] != None:
			self.country_code = locationData["country_code"]
		if "location" in locationData and locationData["location"] != None:
			self.location["x"] = round(float(locationData["location"]["x"]))
			self.location["y"] = round(float(locationData["location"]["y"]))
		elif "latitude" in locationData:
			if locationData["latitude"] != None:
				self.location["x"] = round(float(locationData["latitude"]), 2)
			if locationData["longitude"] != None:	
				self.location["y"] = round(float(locationData["longitude"]), 2)
		if locationData["elevation"] != None:
			self.elevation = locationData["elevation"]
		if locationData["year_constructed"] != None:
			self.year_constructed = locationData["year_constructed"]
		if locationData["dome"] == "true":
			self.dome = True
		if locationData["timezone"] != None:
			self.timezone = locationData["timezone"]

class CFDB_Record():
	def __init__(self):
		self.games = 0
		self.wins = 0
		self.losses = 0
		self.ties = 0

	def Parse(self, recordData):
		self.games = recordData["games"]
		self.wins = recordData["wins"]
		self.losses = recordData["losses"]
		self.ties = recordData["ties"]

class CFDB_TeamRecord():
	def __init__(self):
		self.year = 0
		self.team = ""
		self.conference = ""
		self.division = ""
		self.expectedWins = 0
		self.total = CFDB_Record()
		self.conferenceGames = CFDB_Record()
		self.homeGames = CFDB_Record()
		self.awayGames = CFDB_Record()
		
	def Parse(self, teamRecordData):
		self.year = teamRecordData["year"]
		self.team = teamRecordData["team"]
		self.conference = teamRecordData["conference"]
		self.division = teamRecordData["division"]
		self.expectedWins = teamRecordData["expectedWins"]
		self.total.Parse(teamRecordData["total"])
		self.conferenceGames.Parse(teamRecordData["conferenceGames"])
		self.homeGames.Parse(teamRecordData["homeGames"])
		self.awayGames.Parse(teamRecordData["awayGames"])

class CFDB_Team():
	def __init__(self, teamId = 0):
		self.id = teamId
		self.school = ""
		self.mascot = ""
		self.abbreviation = ""
		self.alt_name_1 = ""
		self.alt_name_2 = ""
		self.alt_name_3 = ""
		self.classification = ""
		self.conference = ""
		self.division = ""
		self.color = ""
		self.alt_color = ""
		self.logo = []
		self.twitter = ""
		self.location = CFDB_Location()

	def Parse(self, teamData):
		self.id = teamData["id"]
		self.school = teamData["school"]
		if teamData["mascot"] != None:
			self.mascot = teamData["mascot"]
		if teamData["abbreviation"] != None:
			self.abbreviation = teamData["abbreviation"]
		if teamData["alt_name1"] != None:
			self.alt_name_1 = teamData["alt_name1"]
		if teamData["alt_name2"] != None:
			self.alt_name_2 = teamData["alt_name2"]
		if teamData["alt_name3"] != None:
			self.alt_name_3 = teamData["alt_name3"]
		if teamData["classification"] != None:
			self.classification = teamData["classification"]
		if teamData["conference"] != None:
			self.conference = teamData["conference"]
		if "division" in teamData:
			self.division = teamData["division"]
		if teamData["color"] != None:
			self.color = teamData["color"]
		if teamData["alt_color"] != None:
			self.alt_color = teamData["alt_color"]
		if teamData["logos"] != None and len(teamData["logos"]) != 0:	
			for logo in teamData["logos"]:
				self.logo.append(logo)
		else:
			self.logo.append("")
		if teamData["twitter"] != None:
			self.twitter = teamData["twitter"]
		self.location.Parse(teamData["location"])

class CFDB_TeamSeason():
	def __init__(self):
		self.school = ""
		self.year = ""
		self.games = 0
		self.wins = 0
		self.losses = 0
		self.ties = 0
		self.preseason_rank = 0
		self.postseason_rank = 0
		self.srs = 0.0
		self.sp_overall = 0.0
		self.sp_offense = 0.0
		self.sp_defense = 0.0

	def Parse(self, teamSeasonData):
		self.school = teamSeasonData["school"]
		self.year = teamSeasonData["year"]
		self.games = teamSeasonData["games"]
		self.wins = teamSeasonData["wins"]
		self.losses = teamSeasonData["losses"]
		self.ties = teamSeasonData["ties"]
		self.preseason_rank = teamSeasonData["preseason_rank"]
		self.postseason_rank = teamSeasonData["postseason_rank"]
		self.srs = teamSeasonData["srs"]
		self.sp_overall = teamSeasonData["sp_overall"]
		self.sp_offense = teamSeasonData["sp_offense"]
		self.sp_defense = teamSeasonData["sp_defense"]

class CFDB_Rank():
	def __init__(self):
		self.rank = 0
		self.school = ""
		self.conference = ""
		self.firstPlaceVotes = 0
		self.points = 0

	def Parse(self, rankData):
		self.rank = rankData["rank"]
		self.school = rankData["school"]
		self.conference = rankData["conference"]
		self.firstPlaceVotes = rankData["firstPlaceVotes"]
		self.points = rankData["points"]

class CFDB_Poll():
	def __init__(self):
		self.poll = ""
		self.ranks = []

	def Parse(self, pollData):
		self.poll = pollData["poll"]
		for ranks in pollData["ranks"]:
			rank = CFDB_Rank()
			rank.Parse(ranks)
			self.ranks.append(rank)

class CFDB_RankingWeek():
	def __init__(self):
		self.season = 0
		self.seasonType = ""
		self.week = 0
		self.polls = []

	def Parse(self, rankingWeekData):
		self.season = rankingWeekData["season"]
		self.seasonType = rankingWeekData["seasonType"]
		self.week = rankingWeekData["week"]
		for pollData in rankingWeekData["polls"]:
			poll = CFDB_Poll()
			poll.Parse(pollData)
			self.polls.append(poll)

class CFDB_TeamMatchupGames():
	def __init__(self):
		self.season = 0
		self.week = 0
		self.season_type = ""
		self.date = ""
		self.neutralSite = False
		self.venue = ""
		self.homeTeam = ""
		self.homeScore = 0
		self.awayTeam = ""
		self.awayScore = 0
		self.winner = ""

	def Parse(self, teamMatchupGamesData):
		self.season = teamMatchupGamesData["season"]
		self.week = teamMatchupGamesData["week"]
		self.season_type = teamMatchupGamesData["season_type"]
		self.date = teamMatchupGamesData["date"]
		if teamMatchupGamesData["neutralSite"] == True:
			self.neutralSite = True
		self.venue = teamMatchupGamesData["venue"]
		self.homeTeam = teamMatchupGamesData["homeTeam"]
		self.homeScore = teamMatchupGamesData["homeScore"]
		self.awayTeam = teamMatchupGamesData["awayTeam"]
		self.awayScore = teamMatchupGamesData["awayScore"]
		self.winner = teamMatchupGamesData["winner"]

class CFDB_TeamMatchup():
	def __init__(self):
		self.team1 = ""
		self.team2 = ""
		self.startYear = 0
		self.endYear = 0
		self.team1Wins = 0
		self.team2Wins = 0
		self.ties = 0
		self.games = []

	def Parse(self, teamMatchupData):
		self.team1 = teamMatchupData["team1"]
		self.team2 = teamMatchupData["team2"]
		self.startYear = teamMatchupData["startYear"]
		self.endYear = teamMatchupData["endYear"]
		self.team1Wins = teamMatchupData["team1Wins"]
		self.team2Wins = teamMatchupData["team2Wins"]
		self.ties = teamMatchupData["ties"]
		for gameData in teamMatchupData["games"]:
			game = CFDB_TeamMatchupGames()
			game.Parse(gameData)
			self.games.append(game)

class CFDB_Week():
	def __init__(self):
		self.season = 0
		self.week = 0
		self.seasonType = ""
		self.firstGameStart = ""
		self.lastGameStart = ""

	def Parse(self, weekData):
		self.season = weekData["season"]
		self.week = weekData["week"]
		self.seasonType = weekData["seasonType"]
		self.firstGameStart = weekData["firstGameStart"]
		self.lastGameStart = weekData["lastGameStart"]

class CFDB_ScoreboardVenue():
	def __init__(self):
		self.name = ""
		self.city = ""
		self.state = ""

	def Parse(self, scoreboardVenueData):
		if scoreboardVenueData["name"] != None:
			self.name = scoreboardVenueData["name"]
		if scoreboardVenueData["city"] != None:
			self.city = scoreboardVenueData["city"]
		if scoreboardVenueData["state"] != None:
			self.state = scoreboardVenueData["state"]

	def Print(self):
		print('\tVenue:')
		print('\t\tname: {0}'.format(self.name))
		print('\t\tcity: {0}'.format(self.city))
		print('\t\tstate: {0}'.format(self.state))

class CFDB_ScoreboardTeam():
	def __init__(self):
		self.id = 0
		self.name = ""
		self.conference = ""
		self.classification = ""
		self.points = 0

	def Parse(self, scoreboardTeamData):
		if scoreboardTeamData["id"] != None:
			self.id = scoreboardTeamData["id"]
		if scoreboardTeamData["name"] != None:
			self.name = scoreboardTeamData["name"]
		if scoreboardTeamData["conference"] != None:
			self.conference = scoreboardTeamData["conference"]
		if scoreboardTeamData["classification"] != None:
			self.classification = scoreboardTeamData["classification"]
		if scoreboardTeamData["points"] != None:
			self.points = scoreboardTeamData["points"]

	def Print(self):
		print('\tTeam:')
		print('\t\tid: {0}'.format(self.id))
		print('\t\tname: {0}'.format(self.name))
		print('\t\tconference: {0}'.format(self.conference))
		print('\t\tclassification: {0}'.format(self.classification))
		print('\t\tpoints: {0}'.format(self.points))

class CFDB_ScoreboardWeather():
	def __init__(self):
		self.temperature = 0.0
		self.description = ""
		self.windSpeed = 0.0
		self.windDirection = 0.0

	def Parse(self, scoreboardWeatherData):
		if scoreboardWeatherData["temperature"] != None:
			self.temperature = scoreboardWeatherData["temperature"]
		if scoreboardWeatherData["description"] != None:
			self.description = scoreboardWeatherData["description"]
		if scoreboardWeatherData["windSpeed"] != None:
			self.windSpeed = scoreboardWeatherData["windSpeed"]
		if scoreboardWeatherData["windDirection"] != None:
			self.windDirection = scoreboardWeatherData["windDirection"]

	def Print(self):
		print('\tWeather:')
		print('\t\ttemperature: {0}'.format(self.temperature))
		print('\t\tdescription: {0}'.format(self.description))
		print('\t\twindSpeed: {0}'.format(self.windSpeed))
		print('\t\twindDirection: {0}'.format(self.windDirection))

class CFDB_ScoreboardBetting():
	def __init__(self):
		self.spread = 0.0
		self.overUnder = 0.0
		self.homeMoneyLine = 0
		self.awayMoneyLine = 0

	def Parse(self, scoreboardBettingData):
		if scoreboardBettingData["spread"] != None:
			self.spread = scoreboardBettingData["spread"]
		if scoreboardBettingData["overUnder"] != None:
			self.overUnder = scoreboardBettingData["overUnder"]
		if "homeMoneyLine" in scoreboardBettingData and scoreboardBettingData["homeMoneyLine"] != None:
			self.homeMoneyLine = scoreboardBettingData["homeMoneyLine"]
		if "awayMoneyLine" in scoreboardBettingData and scoreboardBettingData["awayMoneyLine"] != None:
			self.awayMoneyLine = scoreboardBettingData["awayMoneyLine"]

	def Print(self):
		print('\tBetting:')
		print('\t\tspread: {0}'.format(self.spread))
		print('\t\toverUnder: {0}'.format(self.overUnder))
		print('\t\thomeMoneyLine: {0}'.format(self.homeMoneyLine))
		print('\t\tawayMoneyLine: {0}'.format(self.awayMoneyLine))

class CFDB_ScoreboardGame():
	def __init__(self):
		self.id = 0
		self.startDate = ""
		self.startTimeTBD = False
		self.tv = ""
		self.neutralSite = False
		self.conferenceGame = False
		self.status = ""
		self.period = 0
		self.clock = ""
		self.situation = ""
		self.possession = ""
		self.venue = CFDB_ScoreboardVenue()
		self.homeTeam = CFDB_ScoreboardTeam()
		self.awayTeam = CFDB_ScoreboardTeam()
		self.weather = CFDB_ScoreboardWeather()
		self.betting = CFDB_ScoreboardBetting()

	def Parse(self, scoreboardGameData):
		self.id = scoreboardGameData["id"]
		self.startDate = scoreboardGameData["startDate"]
		if scoreboardGameData["startTimeTBD"] == True:
			self.scoreboardGameData = True
		self.tv = scoreboardGameData["tv"]
		if scoreboardGameData["neutralSite"] == True:
			self.neutralSite = True
		if scoreboardGameData["conferenceGame"] == True:
			self.conferenceGame = True
		if scoreboardGameData["status"] != None:
			self.status = scoreboardGameData["status"]
		if scoreboardGameData["period"] != None:
			self.period = scoreboardGameData["period"]
		if scoreboardGameData["clock"] != None:
			self.clock = scoreboardGameData["clock"]
		if scoreboardGameData["situation"] != None:
			self.situation = scoreboardGameData["situation"]
		if scoreboardGameData["possession"] != None:
			self.possession = scoreboardGameData["possession"]
		self.venue.Parse(scoreboardGameData["venue"])
		self.homeTeam.Parse(scoreboardGameData["homeTeam"])
		self.awayTeam.Parse(scoreboardGameData["awayTeam"])
		self.weather.Parse(scoreboardGameData["weather"])
		self.betting.Parse(scoreboardGameData["betting"])

	def Print(self):
		print('Scoreboard Game:')
		print('\tid: {0}'.format(self.id))
		print('\tstartDate: {0}'.format(self.startDate))
		print('\tstartTimeTBD: {0}'.format(self.startTimeTBD))
		print('\ttv: {0}'.format(self.tv))
		print('\tneutralSite: {0}'.format(self.neutralSite))
		print('\tconferenceGame: {0}'.format(self.conferenceGame))
		print('\tstatus: {0}'.format(self.status))
		print('\tperiod: {0}'.format(self.period))
		print('\tclock: {0}'.format(self.clock))
		print('\tsituation: {0}'.format(self.clock))
		print('\tpossession: {0}'.format(self.possession))
		self.venue.Print()
		self.homeTeam.Print()
		self.awayTeam.Print()
		self.weather.Print()
		self.betting.Print()
