import os
import sys
import MySQLdb
from CFDB_Classes import *
from AFFP_Classes import *

class CFDB_Database():
	host = "127.0.0.1"
# Add football database credentials here
	user = ""
	passwd = ""
	db = ""
	__databaseInitialized = 0
	
	def __init__(self):
		self.conn = MySQLdb.connect (self.host, self.user, self.passwd, self.db)
		self.cursor = self.conn.cursor()

	def DoesGameExist(self, game):
		cypher = "SELECT * FROM Games WHERE id={0}".format(game.id)

		try:
			self.cursor.execute(cypher)
			gameData = self.cursor.fetchone()
			if gameData == None:
				return False
			return True
		except MySQLdb.Error as e:
			print("Error in {0}: {1}".format(sys._getframe().f_code.co_name, e))
			return False

	def UpdatePicks( self, games, week, season ):
		picks = self.GetPicksByWeek( week, season )
		for pickID in picks:
			for game in games:
				if game.id == pickID:
					if game.completed == True:
						if game.home_points > game.away_points:
							self.SetPickWinnerByGameId(game.id, game.home_id)
						elif game.away_points > game.home_points:
							self.SetPickWinnerByGameId(game.id, game.away_id)

	def GetPicksByWeek(self, week, season):
		cypher = 'SELECT GameId FROM Picks WHERE week={0} AND season={1}'.format(week, season)

		try:
			self.cursor.execute(cypher)
			return self.cursor.fetchall()
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def GetCurrentWeek(self):
		cypher = 'SELECT MAX(week) FROM Games WHERE id IN (SELECT id FROM Scoreboard)'

		try:
			self.cursor.execute(cypher)
			currentWeek = int(self.cursor.fetchone()[0])
			return currentWeek
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def GetCurrentSeason(self):
		cypher = 'SELECT DISTINCT(season_type) FROM Games WHERE id IN (SELECT id FROM Scoreboard)'

		try:
			self.cursor.execute(cypher)
			currentSeason = self.cursor.fetchone()[0]
			return currentSeason
		except MySQLdb.Error as e:
			print(cypher)
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def GetNumberOfWeeksInSeason(self):
		cypher = 'SELECT MAX(week) FROM Calendar WHERE seasonType="regular"'

		try:
			self.cursor.execute(cypher)
			lastWeek = int(self.cursor.fetchone()[0])
			return lastWeek
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def GetScoreboardGames(self):
		cypher = 'SELECT * From Scoreboard'
		gameArray = []

		try:
			self.cursor.execute( cypher )
			scoreboardData = self.cursor.fetchall()
			for scoreboardGame in scoreboardData:
				gameString = '{0}'.format( scoreboardGame )
				gameString = gameString.lstrip( "(" )
				gameString = gameString.rstrip( ")" )
				gameData = gameString.split( "," )
				newGame = CFDB_ScoreboardGame()
				newGame.id = int( gameData[0] )
				gameData[1] = gameData[1].rstrip(" '\"")
				newGame.startDate = gameData[1].lstrip(" '\"")
				if int(gameData[2]) != 0:
					newGame.startTimeTBD = True
				newGame.tv = gameData[3]
				if int(gameData[4]) != 0:
					newGame.neutralSite = True
				if int(gameData[5]) != 0:
					newGame.conferenceGame = True
				gameData[6] = gameData[6].rstrip(" '\"")
				newGame.status = gameData[6].lstrip(" '\"")
				newGame.period = int(gameData[7])
				gameData[8] = gameData[8].rstrip(" '\"")
				newGame.clock = gameData[8].lstrip(" '\"")
				gameData[9] = gameData[9].rstrip(" '\"")
				newGame.situation = gameData[9].lstrip(" '\"")
				gameData[10] = gameData[10].rstrip(" '\"")
				newGame.possession = gameData[10].lstrip(" '\"")
				gameData[11] = gameData[11].rstrip(" '\"")
				newGame.venue.name = gameData[11].lstrip(" '\"")
				gameData[12] = gameData[12].rstrip(" '\"")
				newGame.venue.city = gameData[12].lstrip(" '\"")
				gameData[13] = gameData[13].rstrip(" '\"")
				newGame.venue.state = gameData[13].lstrip(" '\"")
				newGame.homeTeam.id = int( gameData[14] )
				gameData[15] = gameData[15].rstrip(" '\"")
				newGame.homeTeam.name = gameData[15].lstrip(" '\"")
				gameData[16] = gameData[16].rstrip(" '\"")
				newGame.homeTeam.conference = gameData[16].lstrip(" '\"")
				gameData[17] = gameData[17].rstrip(" '\"")
				newGame.homeTeam.classification = gameData[17].lstrip(" '\"")
				newGame.homeTeam.points = int( gameData[18] )
				newGame.awayTeam.id = int( gameData[19] )
				gameData[20] = gameData[20].rstrip(" '\"")
				newGame.awayTeam.name = gameData[20].lstrip(" '\"")
				gameData[21] = gameData[21].rstrip(" '\"")
				newGame.awayTeam.conference = gameData[21].lstrip(" '\"")
				gameData[22] = gameData[22].rstrip(" '\"")
				newGame.awayTeam.classification = gameData[22].lstrip(" '\"")
				newGame.awayTeam.points = int( gameData[23] )
				gameData[24] = gameData[24][gameData[24].find('(')+1:gameData[24].find(')')]
				gameData[24] = gameData[24].replace("'", '')
				newGame.weather.temperature = float( gameData[24] )
				gameData[25] = gameData[25].rstrip(" '\"")
				newGame.weather.description = gameData[25]
				gameData[26] = gameData[26][gameData[26].find('(')+1:gameData[26].find(')')]
				gameData[26] = gameData[26].replace("'", '')
				newGame.weather.windSpeed = float( gameData[26] )
				gameData[27] = gameData[27][gameData[27].find('(')+1:gameData[27].find(')')]
				gameData[27] = gameData[27].replace("'", '')
				newGame.weather.windDirection = float( gameData[27] )
				gameData[28] = gameData[28][gameData[28].find('(')+1:gameData[28].find(')')]
				gameData[28] = gameData[28].replace("'", '')
				newGame.betting.spread = float( gameData[28] )
				gameData[29] = gameData[29][gameData[29].find('(')+1:gameData[29].find(')')]
				gameData[29] = gameData[29].replace("'", '')
				newGame.betting.overUnder = float( gameData[29] )
				newGame.betting.homeMoneyLine = int( gameData[30] )
				newGame.betting.awayMoneyLine = int( gameData[31] )
				gameArray.append( newGame )
			return gameArray
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	def GetAllGameDataByWeek( self, week, season ):
		gameWeekData = []
		gameArray = []
		cypher = 'SELECT * FROM Games WHERE week={0} AND season_type="{1}"'.format( week, season )
		try:
			self.cursor.execute( cypher )
			gameWeekData = self.cursor.fetchall()
			for game in gameWeekData:
				gameString = '{0}'.format( game )
				gameString = gameString.lstrip( "(" )
				gameString = gameString.rstrip( ")" )
				gameData = gameString.split( "," )
				newGame = CFDB_Game()
				newGame.id = int( gameData[0] )
				newGame.season = int( gameData[1] )
				newGame.week = int( gameData[2] )
				newGame.season_type = gameData[3]
				newGame.start_data = gameData[4]
				if int(gameData[5]) != 0:
					newGame.start_time_tbd = True
				if int(gameData[6]) != 0:
					newGame.completed = True
				if int(gameData[7]) != 0:
					newGame.neutral_site = True
				if int(gameData[8]) != 0:
					newGame.conference_game = True
				newGame.attendance = int( gameData[9] )
				newGame.venue_id = int( gameData[10] )
				newGame.home_id = int( gameData[11] )
				newGame.home_team = gameData[12]
				newGame.home_conference = gameData[13]
				newGame.home_division = gameData[14]
				newGame.home_points = int( gameData[15] )
				newGame.home_points_q1 = int( gameData[16] )
				newGame.home_points_q2 = int( gameData[17] )
				newGame.home_points_q3 = int( gameData[18] )
				newGame.home_points_q4 = int( gameData[19] )
				newGame.home_points_ot = int( gameData[20] )
				gameData[21] = gameData[21][gameData[21].find('(')+1:gameData[21].find(')')]
				gameData[21] = gameData[21].replace("'", '')
				newGame.home_post_win_prob = float( gameData[21] )
				newGame.home_pregame_elo = int( gameData[22] )
				newGame.home_postgame_elo = int( gameData[23] )
				newGame.away_id = int( gameData[24] )
				newGame.away_team = gameData[25]
				newGame.away_conference = gameData[26]
				newGame.away_division = gameData[27]
				newGame.away_points = int( gameData[28] )
				newGame.away_points_q1 = int( gameData[29] )
				newGame.away_points_q2 = int( gameData[30] )
				newGame.away_points_q3 = int( gameData[31] )
				newGame.away_points_q4 = int( gameData[32] )
				newGame.away_points_ot = int( gameData[33] )
				gameData[34] = gameData[34][gameData[34].find('(')+1:gameData[34].find(')')]
				gameData[34] = gameData[34].replace("'", '')
				newGame.away_post_win_prob = float( gameData[34] )
				newGame.away_pregame_elo = int( gameData[35] )
				newGame.away_postgame_elo = int( gameData[36] )
				gameData[37] = gameData[37][gameData[37].find('(')+1:gameData[37].find(')')]
				gameData[37] = gameData[37].replace("'", '')
				newGame.excitement_index = float( gameData[37] )
				newGame.highlights = gameData[38]
				newGame.notes = gameData[39]
				gameArray.append(newGame)
			return gameArray
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	def GetTeamLogos(self):
		cypher = 'SELECT logo FROM Teams';
		logos = []

		try:
			self.cursor.execute(cypher)
			logoURLs = self.cursor.fetchall()
			for logoURL in logoURLs:
				logos.append( logoURL )
			return logos
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	def GetVisitorScoreForGame(self, gameId):
		getVisitorScoreCommand = 'SELECT VisitorScore FROM Games WHERE id={0}'.format(gameId)
		try:
			self.cursor.execute( getVisitorScoreCommand )
			visitorScore = self.cursor.fetchone()
			return visitorScore[0]
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	
	def GetHomeScoreForGame(self, gameId):
		getHomeScoreCommand = 'SELECT HomeScore FROM Games WHERE id={0}'.format(gameId)
		try:
			self.cursor.execute( getHomeScoreCommand )
			homeScore = self.cursor.fetchone()
			return homeScore[0]
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	def GetVisitorIdByGame( self, gameId ):
		getVisitorIdCommand = 'SELECT VisitorID FROM Games WHERE id={0}'.format( gameId )
		try:
			self.cursor.execute( getVisitorIdCommand )
			visitorId = self.cursor.fetchone()
			return visitorId[0]
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None
			
	def GetHomeIdByGame( self, gameId ):
		getHomeIdCommand = 'SELECT HomeID FROM Games WHERE id={0}'.format( gameId )
		try:
			self.cursor.execute( getHomeIdCommand )
			homeId = self.cursor.fetchone()
			return homeId[0]
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	def ResetTeamRankings( self, week ):
		sqlCommand = "DELETE FROM Rankings WHERE Week={0}".format( week )

		try:
			self.cursor.execute( sqlCommand )
			self.conn.commit()
			return 0
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def SetTeamRank( self, team, rank, week ):
		sqlCommand = "INSERT INTO Rankings (teamId, week, teamRank) VALUES ({0},{1},{2})".format( team, week, rank )

		try:
			self.cursor.execute( sqlCommand )
			self.conn.commit()
			return 0
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def GetGameStatus( self, gameId ):
		sqlCommand = "SELECT GameTime FROM Games WHERE id={0}".format( gameId )

		try:
			self.cursor.execute( sqlCommand )
			result = self.cursor.fetchone()
			return result[0]
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def GetNumberOfWinners( self, gameId, winner ):
		sqlCommand = "SELECT COUNT(*) FROM UserPicks WHERE gameId={0} AND winner={1}".format( gameId, winner )

		try:
			self.cursor.execute( sqlCommand )
			result = self.cursor.fetchone()
			return result[0]
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return -1

	def ConvertDatabaseTeamsToDictionary(self, teams):
		databaseTeams = {}

		for team in teams:
			teamObject = NCAAFootballTeam()
			teamObject.id = int(team[0])
			teamObject.name = team[1]
			teamObject.displayName = team[2]
			teamObject.abbreviation = team[3]
			teamObject.shortDisplayName = team[4]
			teamObject.primaryColor = team[5]
			teamObject.alternateColor = team[6]
			teamObject.conference = team[7]
			teamObject.division = team[8]
			teamObject.totalWins = int(team[9])
			teamObject.totalLosses = int(team[10])
			teamObject.totalTies = int(team[11])
			teamObject.homeWins = int(team[12])
			teamObject.homeLosses = int(team[13])
			teamObject.homeTies = int(team[14])
			teamObject.awayWins = int(team[15])
			teamObject.awayLosses = int(team[16])
			teamObject.awayTies = int(team[17])
			teamObject.confWins = int(team[18])
			teamObject.confLosses = int(team[19])
			teamObject.confTies = int(team[20])
			teamObject.url = team[21]
			teamObject.icon = team[22]
			databaseTeams[teamObject.id] = teamObject
		return databaseTeams

	def GetAllTeamsFromDatabase(self):
		query = 'SELECT * FROM Teams'
		currentTeams = {}

		try:
			self.cursor.execute(query)
			teams = self.cursor.fetchall()
			return self.ConvertDatabaseTeamsToDictionary(teams)
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	def ConvertDatabaseGamesToDictionary(self, games):
		databaseGames = {}

		for game in games:
			gameObject = NCAAFootballGame()
			gameObject.gameID = game[0]
			gameObject.awayID = game[1]
			gameObject.awayFirstScore = game[2]
			gameObject.awaySecondScore = game[3]
			gameObject.awayThirdScore = game[4]
			gameObject.awayFourthScore = game[5]
			gameObject.awayOTScore = game[6]
			gameObject.awayFinalScore = game[7]
			gameObject.homeID = game[8]
			gameObject.homeFirstScore = game[9]
			gameObject.homeSecondScore = game[10]
			gameObject.homeThirdScore = game[11]
			gameObject.homeFourthScore = game[12]
			gameObject.homeOTScore = game[13]
			gameObject.homeFinalScore = game[14]
			gameObject.winnerID = game[15]
			gameObject.gameStatus = game[16]
			gameObject.gameWeek = game[17]
			gameObject.gameSeason = game[18]
			gameObject.gameDate = game[19]
			gameObject.gameTime = game[20]
			gameObject.gameVenue = game[21]
			gameObject.gameOverUnder = game[22]
			gameObject.gameOdds = game[23]
			gameObject.gameDivision = game[24]
			gameObject.neutralSite = game[25]
			gameObject.gameIndex = game[26]
			databaseGames[gameObject.gameID] = gameObject
		return databaseGames
	
	def GetWeeklyGamesFromDatabase(self, week, season):
		query = 'SELECT * FROM Games WHERE GameWeek={0} AND GameSeason={1}'.format(week, season)

		try:
			self.cursor.execute(query)
			games = self.cursor.fetchall()
			return self.ConvertDatabaseGamesToDictionary(games)
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None

	def GetAllGamesFromDatabase(self):
		query = 'SELECT * FROM Games'

		try:
			self.cursor.execute(query)
			games = self.cursor.fetchall()
			return self.ConvertDatabaseGamesToDictionary(games)
		except MySQLdb.Error as e:
			print('Error in {0}: {1}'.format(sys._getframe().f_code.co_name, e))
			return None
